﻿using OpenGL;
using System.Windows.Forms;

namespace GameApp
{
    public partial class MainForm : Form
    {
        DisplayManager _displayManager = new DisplayManager();

        RawModel _model;
        Loader _loader;
        Renderer _renderer;

        float[] vertices =
            {
                -0.5f, 0.5f, 0f,
                -0.5f, -0.5f, 0f,
                0.5f, -0.5f, 0f,

                0.5f, -0.5f, 0f,
                0.5f, 0.5f, 0f,
                -0.5f, 0.5f, 0f
            };

        public MainForm()
        {
            InitializeComponent();
        }

        private void glControl_ContextCreated(object sender, OpenGL.GlControlEventArgs e)
        {
            GlControl glControl = (GlControl)sender;
            _displayManager.createDisplay(glControl);

            _loader = new Loader();
            _model = _loader.loadToVAO(vertices);
            _renderer = new Renderer();
        }
        private void glControl_ContextUpdate(object sender, GlControlEventArgs e)
        {
        }

        private void glControl_ContextDestroying(object sender, GlControlEventArgs e)
        {
            _loader.CleanUp();
        }

        private void glControl_Render(object sender, OpenGL.GlControlEventArgs e)
        {
            Control senderControl = (Control)sender;
            Gl.Viewport(0, 0, senderControl.ClientSize.Width, senderControl.ClientSize.Height);

            _renderer.Prepare();
            _renderer.Render(_model);

            _displayManager.updateDisplay();
        }
    }
}
